<?php

class EPAY extends PaymentModule
{
	private	$_html = '';
	private $_postErrors = array();
  private $_translations = array('en', 'da');
  private $_translationdefault = 'en';

	public function __construct()
	{
		$this->name = 'epay';
		$this->tab = 'Payment';
		$this->version = 1.00;

        parent::__construct();

        /* The parent construct is required for translations */
		    $this->page = basename(__FILE__, '.php');
        $this->displayName = 'ePay';
        $this->description = 'Accept Dankort, eDankort, VISA, Electron, MasterCard, Maestro, JCB, Diners, AMEX, EWIRE, Nordea and Danske Bank payments by ePay Secure Online Payment System';
	}

	public function install()
	{
		parent::install();
		Configuration::updateValue('EPAY_CARDTYPE_DANKORT', '1');
		Configuration::updateValue('EPAY_CARDTYPE_INTERNATIONAL', '1');
		Configuration::updateValue('EPAY_CARDTYPE_DINERS', '1');
		Configuration::updateValue('EPAY_CARDTYPE_AMEX', '1');
		Configuration::updateValue('EPAY_CARDTYPE_FORBRUGSFORENINGEN', '1');
		Configuration::updateValue('EPAY_CARDTYPE_EWIRE', '1');
		Configuration::updateValue('EPAY_CARDTYPE_NORDEA', '1');
		Configuration::updateValue('EPAY_CARDTYPE_DANSKEBANK', '1');
		$this->registerHook('payment');
	}

	public function uninstall()
	{
		parent::uninstall();
	}

	public function getContent()
	{
		$this->_html = '<h2>ePay</h2>';
		if (isset($_POST['SaveSettings']))
		{
			if (empty($_POST['merchantnumber']))
				$this->_postErrors[] = 'Merchantnumber is required. If you don\'t have one please contact ePay on support@epay.dk in order to obtain one!';
        
			if (!sizeof($this->_postErrors))
			{
				Configuration::updateValue('EPAY_MERCHANTNUMBER', $_POST['merchantnumber']);
				Configuration::updateValue('EPAY_INSTANTCAPTURE', $_POST['instantcapture']);
				Configuration::updateValue('EPAY_GROUP', $_POST['group']);
				Configuration::updateValue('EPAY_AUTHSMS', $_POST['authsms']);
				Configuration::updateValue('EPAY_AUTHMAIL', $_POST['authmail']);
				Configuration::updateValue('EPAY_USE3D', $_POST['use3D']);
				Configuration::updateValue('EPAY_ADDFEE', $_POST['addfee']);
				Configuration::updateValue('EPAY_SPLITPAYMENT', $_POST['splitpayment']);
				Configuration::updateValue('EPAY_MD5MODE', $_POST['md5mode']);
				Configuration::updateValue('EPAY_MD5KEY', $_POST['md5key']);
				Configuration::updateValue('EPAY_CARDTYPE_DANKORT', $_POST['cardtype_dankort']);
				Configuration::updateValue('EPAY_CARDTYPE_INTERNATIONAL', $_POST['cardtype_international']);
				Configuration::updateValue('EPAY_CARDTYPE_DINERS', $_POST['cardtype_diners']);
				Configuration::updateValue('EPAY_CARDTYPE_AMEX', $_POST['cardtype_amex']);
				Configuration::updateValue('EPAY_CARDTYPE_FORBRUGSFORENINGEN', $_POST['cardtype_forbrugsforeningen']);
				Configuration::updateValue('EPAY_CARDTYPE_EWIRE', $_POST['cardtype_ewire']);
				Configuration::updateValue('EPAY_CARDTYPE_NORDEA', $_POST['cardtype_nordea']);
				Configuration::updateValue('EPAY_CARDTYPE_DANSKEBANK', $_POST['cardtype_danske_bank']);
				
				$this->displayConf();
			}
			else
				$this->displayErrors();
		}

		$this->displayEPAY();
		$this->displayFormSettings();
		return $this->_html;
	}

	public function displayConf()
	{
		$this->_html .= '
		<div class="conf confirm">
			<img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />
			'.$this->l('Settings updated').'
		</div>';
	}

	public function displayErrors()
	{
		$nbErrors = sizeof($this->_postErrors);
		$this->_html .= '
		<div class="alert error">
			<h3>'.($nbErrors > 1 ? $this->l('There are') : $this->l('There is')).' '.$nbErrors.' '.($nbErrors > 1 ? $this->l('errors') : $this->l('error')).'</h3>
			<ol>';
		foreach ($this->_postErrors AS $error)
			$this->_html .= '<li>'.$error.'</li>';
		$this->_html .= '
			</ol>
		</div>';
	}
	
	
	public function displayEPAY()
	{
		$this->_html .= '<img src="../modules/epay/logo.gif" style="float:left; margin-right:15px;"><b>This module allows you to accept payments using ePay Online Payment System.</b><br /><br /><br /><br />';
	}

	public function displayFormSettings()
	{
		$conf = Configuration::getMultiple(array('PAYPAL_BUSINESS', 'PAYPAL_SANDBOX'));
		$mermchantnumber = Configuration::get('EPAY_MERCHANTNUMBER');
		$instantcapture = Configuration::get('EPAY_INSTANTCAPTURE');
		$group = Configuration::get('EPAY_GROUP');
		$authsms = Configuration::get('EPAY_AUTHSMS');
		$authmail = Configuration::get('EPAY_AUTHMAIL');
		$use3D = Configuration::get('EPAY_USE3D');
		$addfee = Configuration::get('EPAY_ADDFEE');
		$splitpayment = Configuration::get('EPAY_SPLITPAYMENT');
		$md5mode = Configuration::get('EPAY_MD5MODE');
		$md5key = Configuration::get('EPAY_MD5KEY');
		$cardtype_dankort = Configuration::get('EPAY_CARDTYPE_DANKORT');
		$cardtype_international = Configuration::get('EPAY_CARDTYPE_INTERNATIONAL');
		$cardtype_diners = Configuration::get('EPAY_CARDTYPE_DINERS');
		$cardtype_amex = Configuration::get('EPAY_CARDTYPE_AMEX');
		$cardtype_forbrugsforeningen = Configuration::get('EPAY_CARDTYPE_FORBRUGSFORENINGEN');
		$cardtype_ewire = Configuration::get('EPAY_CARDTYPE_EWIRE');
		$cardtype_nordea = Configuration::get('EPAY_CARDTYPE_NORDEA');
		$cardtype_danske_bank = Configuration::get('EPAY_CARDTYPE_DANSKEBANK');
		

		$this->_html .= '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
		<fieldset>
			<legend><img src="../img/admin/contact.gif" />Settings</legend>
			
			<table border="0" cellpadding="5">
			<tr>
				<td>
					<b>'.$this->l('Merchantnumber (forretningsnummer):').'</b>
				</td>
				<td>
		  		<div class=""><input type="text" size="33" name="merchantnumber" value="'.$mermchantnumber.'" /></div>
		  	</td>
		  </tr>
		  <tr>
				<td>
					<b>'.$this->l('MD5 mode:').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="md5mode" value="0" '.($md5mode == "0" ? 'checked="checked"' : '').' /> '.$this->l('Disabled').'<br />
						<input type="radio" name="md5mode" value="1" '.($md5mode == "1" ? 'checked="checked"' : '').' /> '.$this->l('Back from ePay (secure)').'<br />
						<input type="radio" name="md5mode" value="2" '.($md5mode == "2" ? 'checked="checked"' : '').' /> '.$this->l('On both data to epay and back again (mostly secure)').'<br />
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('MD5 key (password also setup in ePay admin):').'</b>
				</td>
				<td>
		  		<div class=""><input type="text" size="33" name="md5key" value="'.$md5key.'" /></div>
		  	</td>
		  </tr>
      <tr>
      	<td>
      		<b>'.$this->l('Instant capture:').'</b>
      	</td>
      	<td>
				  <div class="">
						<input type="radio" name="instantcapture" value="1" '.($instantcapture ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
						<input type="radio" name="instantcapture" value="0" '.(!$instantcapture ? 'checked="checked"' : '').' /> '.$this->l('No').'
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Group (add transactions to a special group):').'</b>
				</td>
				<td>
				  <div class="">
						<div class=""><input type="text" size="33" name="group" value="'.$group.'" /></div>
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Auth SMS (receive a SMS as the payment is approved):').'</b>
				</td>
				<td>
				  <div class="">
						<div class=""><input type="text" size="33" name="authsms" value="'.$authsms.'" /></div>
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Auth MAIL (receive an email as the payment is approved):').'</b>
				</td>
				<td>
				  <div class="">
						<div class=""><input type="text" size="33" name="authmail" value="'.$authmail.'" /></div>
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('3D secure (for VISA, MasterCard and JCB):').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="use3D" value="0" '.($use3D == "0" ? 'checked="checked"' : '').' /> '.$this->l('Disabled').'
						<input type="radio" name="use3D" value="1" '.($use3D == "1" ? 'checked="checked"' : '').' /> '.$this->l('Enabled').'
						<input type="radio" name="use3D" value="2" '.($use3D == "2" ? 'checked="checked"' : '').' /> '.$this->l('Force 3D secure').'
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Cardholder pays the transaction fee:').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="addfee" value="1" '.($addfee ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
						<input type="radio" name="addfee" value="0" '.(!$addfee ? 'checked="checked"' : '').' /> '.$this->l('No').'
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Splitpayment (multiple shipments same order):').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="splitpayment" value="1" '.($splitpayment ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
						<input type="radio" name="splitpayment" value="0" '.(!$splitpayment ? 'checked="checked"' : '').' /> '.$this->l('No').'
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Accept Dankort, VISA / Dankort and eDankort:').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="cardtype_dankort" value="1" '.($cardtype_dankort ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
						<input type="radio" name="cardtype_dankort" value="0" '.(!$cardtype_dankort ? 'checked="checked"' : '').' /> '.$this->l('No').'
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Accept VISA, Electron, MasterCard, Maestro and JCB:').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="cardtype_international" value="1" '.($cardtype_international ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
						<input type="radio" name="cardtype_international" value="0" '.(!$cardtype_international ? 'checked="checked"' : '').' /> '.$this->l('No').'
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Accept DINERS Club:').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="cardtype_diners" value="1" '.($cardtype_diners ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
						<input type="radio" name="cardtype_diners" value="0" '.(!$cardtype_diners ? 'checked="checked"' : '').' /> '.$this->l('No').'
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Accept American Express:').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="cardtype_amex" value="1" '.($cardtype_amex ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
						<input type="radio" name="cardtype_amex" value="0" '.(!$cardtype_amex ? 'checked="checked"' : '').' /> '.$this->l('No').'
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Accept Forbrugsforeningen:').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="cardtype_forbrugsforeningen" value="1" '.($cardtype_forbrugsforeningen ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
						<input type="radio" name="cardtype_forbrugsforeningen" value="0" '.(!$cardtype_forbrugsforeningen ? 'checked="checked"' : '').' /> '.$this->l('No').'
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Accept EWIRE:').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="cardtype_ewire" value="1" '.($cardtype_ewire ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
						<input type="radio" name="cardtype_ewire" value="0" '.(!$cardtype_ewire ? 'checked="checked"' : '').' /> '.$this->l('No').'
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Accept NORDEA:').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="cardtype_nordea" value="1" '.($cardtype_nordea ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
						<input type="radio" name="cardtype_nordea" value="0" '.(!$cardtype_nordea ? 'checked="checked"' : '').' /> '.$this->l('No').'
					</div>
				</td>
			</tr>
			<tr>
				<td>
					<b>'.$this->l('Accept Danske Bank:').'</b>
				</td>
				<td>
				  <div class="">
						<input type="radio" name="cardtype_danske_bank" value="1" '.($cardtype_danske_bank ? 'checked="checked"' : '').' /> '.$this->l('Yes').'
						<input type="radio" name="cardtype_danske_bank" value="0" '.(!$cardtype_danske_bank ? 'checked="checked"' : '').' /> '.$this->l('No').'
					</div>
				</td>
			</tr>
			<tr>
				<td colspan="2">
					<br /><center><input type="submit" name="SaveSettings" value="Update settings" class="button" /></center>
				</td>
			</tr>
			</table>
		</fieldset>
		</form>
		<fieldset class="width3">
			<legend><img src="../img/admin/warning.gif" />'.$this->l('Information').'</legend>
      You can also setup specific settings from the admin area of ePay: <a href="https://ssl.ditonlinebetalingssystem.dk/admin/" target="_blank">https://ssl.ditonlinebetalingssystem.dk/admin/</a>.
		</fieldset>';
		
		
		
	}
	
	function get_epay_language($strlan)
	{
		switch ($strlan)
		{
			case "da": return 1;
			case "en": return 2;
			case "se": return 3;
			case "no": return 4;
			case "gl": return 5;
			case "is": return 6;
			case "de": return 7;
		}
		
		return 1; // default dk
	}

	public function hookPayment($params)
	{
		global $smarty, $cookie;
    
    $translations = $this->getTranslationsArray();
		$address = new Address(intval($params['cart']->id_address_invoice));
		$customer = new Customer(intval($params['cart']->id_customer));
		$merchantnumber = Configuration::get('EPAY_MERCHANTNUMBER');
		$instantcapture = Configuration::get('EPAY_INSTANTCAPTURE');
		$group = Configuration::get('EPAY_GROUP');
		$authsms = Configuration::get('EPAY_AUTHSMS');
		$authmail = Configuration::get('EPAY_AUTHMAIL');
		$use3D = Configuration::get('EPAY_USE3D');
		$addfee = Configuration::get('EPAY_ADDFEE');
		$splitpayment = Configuration::get('EPAY_SPLITPAYMENT');
    
  	$id_currency = intval($params['cart']->id_currency);
    $currency = new Currency(intval($id_currency));
    
    $language = $this->get_epay_language(Language::getIsoById($cookie->id_lang));

    $id_cart = intval($params['cart']->id);
    $total = number_format(Tools::convertPrice($params['cart']->getOrderTotal(true, 4)+$params['cart']->getOrderShippingCost(), $currency), 2, '', '');
    $accepturl = 'http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'modules/epay/validation.php?language='.$language;
    $ccipage = '';
    
    //
    // Calculate md5
    $md5stamp = '';
    if (Configuration::get('EPAY_MD5MODE')) {
    	$md5stamp = md5($this->get_iso_code($currency->iso_code) . $total . $id_cart . Configuration::get('EPAY_MD5KEY'));
    }

		if (!Validate::isLoadedObject($address) OR !Validate::isLoadedObject($customer))
			return 'Payment error: (invalid address or customer)';
			
		$smarty->assign(array(
			'address' => $address,
			'customer' => $customer,
			'merchantnumber' => $merchantnumber,
      'accepturl' => $accepturl,
			'amount' => $total,
      'currency' => $this->get_iso_code($currency->iso_code),
      'language' => $language,
			'id_cart' => $id_cart,
      'translations' => $translations,
      'instantcapture' => $instantcapture,
      'group' => $group,
      'authsms' => $authsms,
      'authmail' => $authmail,
      'use3D' => $use3D,
      'addfee' => $addfee,
      'md5stamp' => $md5stamp,
      'splitpayment' => $splitpayment,
      'cardtype_dankort' => Configuration::get('EPAY_CARDTYPE_DANKORT'),
      'cardtype_international' => Configuration::get('EPAY_CARDTYPE_INTERNATIONAL'),
      'cardtype_diners' => Configuration::get('EPAY_CARDTYPE_DINERS'),
      'cardtype_amex' => Configuration::get('EPAY_CARDTYPE_AMEX'),
      'cardtype_forbrugsforeningen' => Configuration::get('EPAY_CARDTYPE_FORBRUGSFORENINGEN'),
      'cardtype_ewire' => Configuration::get('EPAY_CARDTYPE_EWIRE'),
      'cardtype_nordea' => Configuration::get('EPAY_CARDTYPE_NORDEA'),
      'cardtype_danske_bank' => Configuration::get('EPAY_CARDTYPE_DANSKEBANK')
		));

		return $this->display(__FILE__, 'epay.tpl');
  }
  
  function get_iso_code($code) {
    switch ($code) {
    	case 'ADP': return '020'; break;
			case 'AED': return '784'; break;
			case 'AFA': return '004'; break;
			case 'ALL': return '008'; break;
			case 'AMD': return '051'; break;
			case 'ANG': return '532'; break;
			case 'AOA': return '973'; break;
			case 'ARS': return '032'; break;
			case 'AUD': return '036'; break;
			case 'AWG': return '533'; break;
			case 'AZM': return '031'; break;
			case 'BAM': return '977'; break;
			case 'BBD': return '052'; break;
			case 'BDT': return '050'; break;
			case 'BGL': return '100'; break;
			case 'BGN': return '975'; break;
			case 'BHD': return '048'; break;
			case 'BIF': return '108'; break;
			case 'BMD': return '060'; break;
			case 'BND': return '096'; break;
			case 'BOB': return '068'; break;
			case 'BOV': return '984'; break;
			case 'BRL': return '986'; break;
			case 'BSD': return '044'; break;
			case 'BTN': return '064'; break;
			case 'BWP': return '072'; break;
			case 'BYR': return '974'; break;
			case 'BZD': return '084'; break;
			case 'CAD': return '124'; break;
			case 'CDF': return '976'; break;
			case 'CHF': return '756'; break;
			case 'CLF': return '990'; break;
			case 'CLP': return '152'; break;
			case 'CNY': return '156'; break;
			case 'COP': return '170'; break;
			case 'CRC': return '188'; break;
			case 'CUP': return '192'; break;
			case 'CVE': return '132'; break;
			case 'CYP': return '196'; break;
			case 'CZK': return '203'; break;
			case 'DJF': return '262'; break;
			case 'DKK': return '208'; break;
			case 'DOP': return '214'; break;
			case 'DZD': return '012'; break;
			case 'ECS': return '218'; break;
			case 'ECV': return '983'; break;
			case 'EEK': return '233'; break;
			case 'EGP': return '818'; break;
			case 'ERN': return '232'; break;
			case 'ETB': return '230'; break;
			case 'EUR': return '978'; break;
			case 'FJD': return '242'; break;
			case 'FKP': return '238'; break;
			case 'GBP': return '826'; break;
			case 'GEL': return '981'; break;
			case 'GHC': return '288'; break;
			case 'GIP': return '292'; break;
			case 'GMD': return '270'; break;
			case 'GNF': return '324'; break;
			case 'GTQ': return '320'; break;
			case 'GWP': return '624'; break;
			case 'GYD': return '328'; break;
			case 'HKD': return '344'; break;
			case 'HNL': return '340'; break;
			case 'HRK': return '191'; break;
			case 'HTG': return '332'; break;
			case 'HUF': return '348'; break;
			case 'IDR': return '360'; break;
			case 'ILS': return '376'; break;
			case 'INR': return '356'; break;
			case 'IQD': return '368'; break;
			case 'IRR': return '364'; break;
			case 'ISK': return '352'; break;
			case 'JMD': return '388'; break;
			case 'JOD': return '400'; break;
			case 'JPY': return '392'; break;
			case 'KES': return '404'; break;
			case 'KGS': return '417'; break;
			case 'KHR': return '116'; break;
			case 'KMF': return '174'; break;
			case 'KPW': return '408'; break;
			case 'KRW': return '410'; break;
			case 'KWD': return '414'; break;
			case 'KYD': return '136'; break;
			case 'KZT': return '398'; break;
			case 'LAK': return '418'; break;
			case 'LBP': return '422'; break;
			case 'LKR': return '144'; break;
			case 'LRD': return '430'; break;
			case 'LSL': return '426'; break;
			case 'LTL': return '440'; break;
			case 'LVL': return '428'; break;
			case 'LYD': return '434'; break;
			case 'MAD': return '504'; break;
			case 'MDL': return '498'; break;
			case 'MGF': return '450'; break;
			case 'MKD': return '807'; break;
			case 'MMK': return '104'; break;
			case 'MNT': return '496'; break;
			case 'MOP': return '446'; break;
			case 'MRO': return '478'; break;
			case 'MTL': return '470'; break;
			case 'MUR': return '480'; break;
			case 'MVR': return '462'; break;
			case 'MWK': return '454'; break;
			case 'MXN': return '484'; break;
			case 'MXV': return '979'; break;
			case 'MYR': return '458'; break;
			case 'MZM': return '508'; break;
			case 'NAD': return '516'; break;
			case 'NGN': return '566'; break;
			case 'NIO': return '558'; break;
			case 'NOK': return '578'; break;
			case 'NPR': return '524'; break;
			case 'NZD': return '554'; break;
			case 'OMR': return '512'; break;
			case 'PAB': return '590'; break;
			case 'PEN': return '604'; break;
			case 'PGK': return '598'; break;
			case 'PHP': return '608'; break;
			case 'PKR': return '586'; break;
			case 'PLN': return '985'; break;
			case 'PYG': return '600'; break;
			case 'QAR': return '634'; break;
			case 'ROL': return '642'; break;
			case 'RUB': return '643'; break;
			case 'RUR': return '810'; break;
			case 'RWF': return '646'; break;
			case 'SAR': return '682'; break;
			case 'SBD': return '090'; break;
			case 'SCR': return '690'; break;
			case 'SDD': return '736'; break;
			case 'SEK': return '752'; break;
			case 'SGD': return '702'; break;
			case 'SHP': return '654'; break;
			case 'SIT': return '705'; break;
			case 'SKK': return '703'; break;
			case 'SLL': return '694'; break;
			case 'SOS': return '706'; break;
			case 'SRG': return '740'; break;
			case 'STD': return '678'; break;
			case 'SVC': return '222'; break;
			case 'SYP': return '760'; break;
			case 'SZL': return '748'; break;
			case 'THB': return '764'; break;
			case 'TJS': return '972'; break;
			case 'TMM': return '795'; break;
			case 'TND': return '788'; break;
			case 'TOP': return '776'; break;
			case 'TPE': return '626'; break;
			case 'TRL': return '792'; break;
			case 'TRY': return '949'; break;
			case 'TTD': return '780'; break;
			case 'TWD': return '901'; break;
			case 'TZS': return '834'; break;
			case 'UAH': return '980'; break;
			case 'UGX': return '800'; break;
			case 'USD': return '840'; break;
			case 'UYU': return '858'; break;
			case 'UZS': return '860'; break;
			case 'VEB': return '862'; break;
			case 'VND': return '704'; break;
			case 'VUV': return '548'; break;
			case 'XAF': return '950'; break;
			case 'XCD': return '951'; break;
			case 'XOF': return '952'; break;
			case 'XPF': return '953'; break;
			case 'YER': return '886'; break;
			case 'YUM': return '891'; break;
			case 'ZAR': return '710'; break;
			case 'ZMK': return '894'; break;
			case 'ZWD': return '716'; break;
    }
    //
    // As default return 208 for Danish Kroner
    //
    return '208';
  }
  
  function getTranslationsArray()
  {
    global $cookie;
    
    $language = Language::getIsoById($cookie->id_lang);
    
    if (!in_array($language, $this->_translations)) {
      $language = $this->_translationdefault;
    }
    
    include(dirname(__FILE__)."/{$language}.php");
    
    return $translations;
  }
}

?>